#ifdef HAVE_CONFIG_H
#include "config.h"
#endif

#define STDC_HEADERS

#ifdef STDC_HEADERS
# include <stdlib.h>
#else
char *malloc ();
#endif

#if defined STDC_HEADERS || defined HAVE_STRING_H
# include <string.h>
#else
# include <strings.h>
# ifndef strrchr
#  define strrchr rindex
# endif
#endif

#include <assert.h>

#ifndef MAXPATHLEN
#  define MAXPATHLEN 256
#endif

char *dirname(char *path)
{
  char tmp[MAXPATHLEN+1], *ptr;
  static char ret[MAXPATHLEN+1];

  if (path == NULL)
    return ".";
  if (strlen(path) == 0)
    return ".";
  if (strcmp(path,"/") == 0)
    return "/";
  if (strcmp(path,".") == 0 || strcmp(path,"./") == 0)
    return ".";
  if (strcmp(path,"..") == 0 || strcmp(path,"../") == 0)
    return ".";
  strncpy(tmp, path, MAXPATHLEN);
  tmp[MAXPATHLEN] = '\0';
  if (tmp[strlen(tmp)-1] == '/')
    tmp[strlen(tmp)-1] = '\0';
  if ((ptr=strrchr(tmp, '/')) == NULL)
    if ((ptr=strrchr(tmp, '\\')) == NULL)	/* Win32 */
      return ".";
  *ptr = '\0';
  strcpy(ret, tmp);
  if (strcmp(ret, "") == 0)
    return "/";
  return ret;
}

char *basename(char *path)
{
  char tmp[MAXPATHLEN+1], *ptr;
  static char ret[MAXPATHLEN+1];

  if (path == NULL)
    return ".";
  if (strlen(path) == 0)
    return "";
  if (strcmp(path,"/") == 0)
    return "/";
  strncpy(tmp, path, MAXPATHLEN);
  tmp[MAXPATHLEN] = '\0';
  if (tmp[strlen(tmp)-1] == '/')
    tmp[strlen(tmp)-1] = '\0';
  if ((ptr=strrchr(tmp, '/')) == NULL) {
    strcpy(ret, tmp);
    return ret;
  }
  ptr++;
  strcpy(ret, ptr);
  return ret;
}
